<template>
  <div class="d-flex flex-col flex-1 flex-ai-start flex-jc-start w-100"
    style="background: white">

    <!-- <div class="text-left text-bold ph-3 pt-2 pb-1">
      <a class="mh-1 text-dark" href="#">Matches</a>
      <a class="mh-1 text-dark" href="#">Messages</a>
    </div> -->

    <ul v-if="Object.keys(matches).length > 0">
      <li v-for="user of matches" :key="user._id"
        class="d-flex flex-row flex-ai-center"
        @click="openMessage(user)">
        <!-- {{ user }} -->
        <img :src="user.media[0]" class="profile-pic">
        <span v-if="user.online" class="online"></span>
        <span class="flex-1 ml-2 mr-1 username">
          {{ user.name.first }}
          <br />
          <small style="color: rgba(0,0,0,.28)"
            v-if="user.messages.length > 0">
            <v-icon name="reply" scale="0.5"/>
            {{ user.messages[user.messages.length - 1].text }}
          </small>
        </span>
        <span v-if="getUnreads(user)"
          class="pin d-flex flex-ai-center flex-jc-center">
          {{ getUnreads(user) }}
        </span>
      </li>
    </ul>
    <div v-else class="no-match d-flex flex-as-center mh-auto ph-5 flex-col mv-auto">
      <div class="d-flex flex-row flex-as-center flex-ai-end">
        <v-icon name="comment" scale="7" class=""/>
        <v-icon name="comment" scale="5" class="fa-flip-horizontal"/>
      </div>
      <h2>Say Hello</h2>
      <small class="text-center">
        Looking to strike up a conversation? When you match with others, you can
        send them a message
      </small>
    </div>
  </div>
</template>

<script>
import Vue from 'vue';
import { mapState } from 'vuex';

export default {
  computed: {
    ...mapState(['matches']),
  },
  mounted() {
    this.$bus.$on('user-online', (user_id) => {
      if (user_id in this.matches)
        Vue.set(this.matches[user_id], 'online', true);
    });

    this.$bus.$on('user-offline', (user_id) => {
      if (user_id in this.matches) {
        Vue.set(this.matches[user_id], 'online', false);
        Vue.set(this.matches[user_id], 'last_active', Date.now());
      }
    });
  },
  methods: {
    openMessage(user) {
      this.$store.commit('setMsgUser', user);
      this.$bus.$emit('open-messages');
    },
    getUnreads(user) {
      let u = this.$store.state.msgUser;
      if (u && u._id === user._id)
        return 0;
      let m = this.$store.state.matches[user._id];
      if (!m)
        return 0;
      return m.messages.filter(
        (mm) => mm.read === false && mm.from === user._id
      ).length;
    },
  },
};
</script>

<style scoped>
ul {
  list-style: none;
  margin: 0;
  padding: 0;
  width: 100%;
  text-align: left;
  font-size: 10pt;
  overflow-x: hidden;
  overflow-y: auto;
}

ul li {
  padding: 1em;
  width: 100%;
  cursor: pointer;
  position: relative;
}

.profile-pic {
  width: 60px;
  height: 60px;
  object-fit: cover;
  border-radius: 50%;
}

span.username {
  text-overflow: ellipsis;
  white-space: nowrap;

  overflow: hidden;
  font-size: 11pt;

  font-weight: bold;
}

span.pin {
  background: var(--color-primary);
  color: white;
  font-size: 10px;
  min-width: 20px;
  height: 20px;
  padding: 0 4px;
  border-radius: 20px;
}

.online {
  position: absolute;
  width: 13px;
  height: 13px;

  left: 55px;
  top: calc(1em);

  border: 2px solid #f5f7fa;

  border-radius: 50%;

  background: var(--color-primary);
}

.no-match .fa-icon {
  display: block;
}

.no-match small {
  color: var(--color-secondary);
  font-size: 1rem;
  max-width: 240px;
}

.no-match .fa-icon:first-child {
  margin-bottom: .1em;
  color: var(--color-light-gray, blue);
}

.no-match .fa-icon:last-child {
  color: var(--color-primary);
  margin-left: -.6em;
}
</style>
